<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/tile/BuildingTile.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_f656290b9017852ece87b8a3712178e6.html">tile</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">BuildingTile.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="BuildingTile_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &quot;<a class="code" href="Tile_8hpp.html">Tile.hpp</a>&quot;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span> </div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="preprocessor">#include &lt;SFML/Graphics.hpp&gt;</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="preprocessor">#include &lt;<a class="code" href="Attributes_8hpp.html">resources/Attributes.hpp</a>&gt;</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span> </div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span>{</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno"><a class="line" href="namespacegg.html#afb77ddca9a821769e28d7b0890ba4a69">   12</a></span><span class="keyword">enum class</span> <a class="code hl_enumeration" href="namespacegg.html#afb77ddca9a821769e28d7b0890ba4a69">BuildingType</a> { <a class="code hl_enumvalue" href="namespacegg.html#afb77ddca9a821769e28d7b0890ba4a69ae546784dabc7c0baa399ef9867bec076">RESIDENTIAL</a>, <a class="code hl_enumvalue" href="namespacegg.html#afb77ddca9a821769e28d7b0890ba4a69acb90f4484ab1c9ce5a9c4328bd3c8dbc">INDUSTRIAL</a> };</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span> </div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html">   14</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1BuildingTile.html">BuildingTile</a> : <span class="keyword">public</span> <a class="code hl_class" href="classgg_1_1Tile.html">Tile</a></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>{</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#a705937dd71116d5ee6bd6f2869e6bb3b">   17</a></span>    <a class="code hl_function" href="classgg_1_1BuildingTile.html#a705937dd71116d5ee6bd6f2869e6bb3b">BuildingTile</a>(<a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a> &amp;attributes);</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#a77adc5a8244e48413334a56c51380aa7">   18</a></span>    <a class="code hl_function" href="classgg_1_1BuildingTile.html#a77adc5a8244e48413334a56c51380aa7">~BuildingTile</a>() <span class="keyword">override</span> = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#a7f6d02f81f64d831817c3e37f537b8ca">   20</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1BuildingTile.html#a7f6d02f81f64d831817c3e37f537b8ca">IsResidential</a>() -&gt; bool;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#a47c85b1dd1592f7de2cdd05b934f52e9">   21</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1BuildingTile.html#a47c85b1dd1592f7de2cdd05b934f52e9">IsIndustrial</a>() -&gt; bool;</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#adb1bf688f0fa132bce941e632ea65694">   23</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1BuildingTile.html#adb1bf688f0fa132bce941e632ea65694">GetAttributes</a>() -&gt; <a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a> <span class="keyword">override</span>;</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#a662c2a65a476d31a4958f9c9c1a1ef18">   24</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1BuildingTile.html#a662c2a65a476d31a4958f9c9c1a1ef18">GetTileType</a>() -&gt; <a class="code hl_enumeration" href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6">TileType</a> <span class="keyword">override</span>;</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#a1308da3c38bb6a81a8cd135145662b55">   25</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1BuildingTile.html#a1308da3c38bb6a81a8cd135145662b55">GetCost</a>() -&gt; <span class="keywordtype">unsigned</span> int;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#a2f7b2d4315bab48a232bbfe23c0ba5d3">   26</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1BuildingTile.html#a2f7b2d4315bab48a232bbfe23c0ba5d3">GetPopulation</a>() -&gt; <span class="keywordtype">unsigned</span> int;</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#a67662dd1d7c62d5835c5120b723ba1e5">   27</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1BuildingTile.html#a67662dd1d7c62d5835c5120b723ba1e5">GetProfit</a>() -&gt; <span class="keywordtype">unsigned</span> int;</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#a0b1b126c456b05e095ce62b931c988b4">   29</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1BuildingTile.html#a0b1b126c456b05e095ce62b931c988b4">BuildingTypeToString</a>(<a class="code hl_enumeration" href="namespacegg.html#afb77ddca9a821769e28d7b0890ba4a69">BuildingType</a> type) -&gt; std::string;</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#a850ccd2fa718bf711ee353da2309f7d1">   30</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1BuildingTile.html#a850ccd2fa718bf711ee353da2309f7d1">StringToBuildingType</a>(<span class="keyword">const</span> std::string &amp;str) -&gt; <a class="code hl_enumeration" href="namespacegg.html#afb77ddca9a821769e28d7b0890ba4a69">BuildingType</a>;</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="classgg_1_1BuildingTile.html#a2dfa2cdebf498afa210e42ef5f1fffa6">   32</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1BuildingTile.html#a2dfa2cdebf498afa210e42ef5f1fffa6">Align</a>() <span class="keyword">override</span>;</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    <a class="code hl_enumeration" href="namespacegg.html#afb77ddca9a821769e28d7b0890ba4a69">BuildingType</a> mType;</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mCost;</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mPopulation;</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>    <span class="keywordtype">int</span> mProfit;</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>};</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>}; <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aAttributes_8hpp_html"><div class="ttname"><a href="Attributes_8hpp.html">Attributes.hpp</a></div></div>
<div class="ttc" id="aTile_8hpp_html"><div class="ttname"><a href="Tile_8hpp.html">Tile.hpp</a></div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html"><div class="ttname"><a href="classgg_1_1Attributes.html">gg::Attributes</a></div><div class="ttdef"><b>Definition:</b> Attributes.hpp:14</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html"><div class="ttname"><a href="classgg_1_1BuildingTile.html">gg::BuildingTile</a></div><div class="ttdef"><b>Definition:</b> BuildingTile.hpp:15</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_a0b1b126c456b05e095ce62b931c988b4"><div class="ttname"><a href="classgg_1_1BuildingTile.html#a0b1b126c456b05e095ce62b931c988b4">gg::BuildingTile::BuildingTypeToString</a></div><div class="ttdeci">static auto BuildingTypeToString(BuildingType type) -&gt; std::string</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_a1308da3c38bb6a81a8cd135145662b55"><div class="ttname"><a href="classgg_1_1BuildingTile.html#a1308da3c38bb6a81a8cd135145662b55">gg::BuildingTile::GetCost</a></div><div class="ttdeci">auto GetCost() -&gt; unsigned int</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_a2dfa2cdebf498afa210e42ef5f1fffa6"><div class="ttname"><a href="classgg_1_1BuildingTile.html#a2dfa2cdebf498afa210e42ef5f1fffa6">gg::BuildingTile::Align</a></div><div class="ttdeci">void Align() override</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_a2f7b2d4315bab48a232bbfe23c0ba5d3"><div class="ttname"><a href="classgg_1_1BuildingTile.html#a2f7b2d4315bab48a232bbfe23c0ba5d3">gg::BuildingTile::GetPopulation</a></div><div class="ttdeci">auto GetPopulation() -&gt; unsigned int</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_a47c85b1dd1592f7de2cdd05b934f52e9"><div class="ttname"><a href="classgg_1_1BuildingTile.html#a47c85b1dd1592f7de2cdd05b934f52e9">gg::BuildingTile::IsIndustrial</a></div><div class="ttdeci">auto IsIndustrial() -&gt; bool</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_a662c2a65a476d31a4958f9c9c1a1ef18"><div class="ttname"><a href="classgg_1_1BuildingTile.html#a662c2a65a476d31a4958f9c9c1a1ef18">gg::BuildingTile::GetTileType</a></div><div class="ttdeci">auto GetTileType() -&gt; TileType override</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_a67662dd1d7c62d5835c5120b723ba1e5"><div class="ttname"><a href="classgg_1_1BuildingTile.html#a67662dd1d7c62d5835c5120b723ba1e5">gg::BuildingTile::GetProfit</a></div><div class="ttdeci">auto GetProfit() -&gt; unsigned int</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_a705937dd71116d5ee6bd6f2869e6bb3b"><div class="ttname"><a href="classgg_1_1BuildingTile.html#a705937dd71116d5ee6bd6f2869e6bb3b">gg::BuildingTile::BuildingTile</a></div><div class="ttdeci">BuildingTile(Attributes &amp;attributes)</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_a77adc5a8244e48413334a56c51380aa7"><div class="ttname"><a href="classgg_1_1BuildingTile.html#a77adc5a8244e48413334a56c51380aa7">gg::BuildingTile::~BuildingTile</a></div><div class="ttdeci">~BuildingTile() override=default</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_a7f6d02f81f64d831817c3e37f537b8ca"><div class="ttname"><a href="classgg_1_1BuildingTile.html#a7f6d02f81f64d831817c3e37f537b8ca">gg::BuildingTile::IsResidential</a></div><div class="ttdeci">auto IsResidential() -&gt; bool</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_a850ccd2fa718bf711ee353da2309f7d1"><div class="ttname"><a href="classgg_1_1BuildingTile.html#a850ccd2fa718bf711ee353da2309f7d1">gg::BuildingTile::StringToBuildingType</a></div><div class="ttdeci">static auto StringToBuildingType(const std::string &amp;str) -&gt; BuildingType</div></div>
<div class="ttc" id="aclassgg_1_1BuildingTile_html_adb1bf688f0fa132bce941e632ea65694"><div class="ttname"><a href="classgg_1_1BuildingTile.html#adb1bf688f0fa132bce941e632ea65694">gg::BuildingTile::GetAttributes</a></div><div class="ttdeci">auto GetAttributes() -&gt; Attributes override</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html"><div class="ttname"><a href="classgg_1_1Tile.html">gg::Tile</a></div><div class="ttdef"><b>Definition:</b> Tile.hpp:21</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
<div class="ttc" id="anamespacegg_html_a08ccf34451b5441314600ac46113a9f6"><div class="ttname"><a href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6">gg::TileType</a></div><div class="ttdeci">TileType</div><div class="ttdef"><b>Definition:</b> Tile.hpp:11</div></div>
<div class="ttc" id="anamespacegg_html_afb77ddca9a821769e28d7b0890ba4a69"><div class="ttname"><a href="namespacegg.html#afb77ddca9a821769e28d7b0890ba4a69">gg::BuildingType</a></div><div class="ttdeci">BuildingType</div><div class="ttdef"><b>Definition:</b> BuildingTile.hpp:12</div></div>
<div class="ttc" id="anamespacegg_html_afb77ddca9a821769e28d7b0890ba4a69acb90f4484ab1c9ce5a9c4328bd3c8dbc"><div class="ttname"><a href="namespacegg.html#afb77ddca9a821769e28d7b0890ba4a69acb90f4484ab1c9ce5a9c4328bd3c8dbc">gg::BuildingType::INDUSTRIAL</a></div><div class="ttdeci">@ INDUSTRIAL</div></div>
<div class="ttc" id="anamespacegg_html_afb77ddca9a821769e28d7b0890ba4a69ae546784dabc7c0baa399ef9867bec076"><div class="ttname"><a href="namespacegg.html#afb77ddca9a821769e28d7b0890ba4a69ae546784dabc7c0baa399ef9867bec076">gg::BuildingType::RESIDENTIAL</a></div><div class="ttdeci">@ RESIDENTIAL</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
